Foreman - Bug #19280

Failed to destroy host on 1.15 RC
04/16/2017 09:36 PM - Josh Benner

Status: Feedback
Priority: Normal
Assignee:

Category: Host creation

Target version:

Difficulty: Fixed in Releases:

Triaged: Found in Releases: 1.15.0
Bugzilla link: Red Hat JIRA:

Pull request:

Description

Upgraded from 1.14 to 1.15.

Every host | attempt to delete yields the error below. Repeating the delete attempt seems to work.

ActiveRecord: :RecordNotDestroyed

Failed to destroy the record
/usr/share/foreman/vendor/ruby/2.3.0/gems/activerecord-4.
in “destroy!'
/usr/share/foreman/vendor/ruby/2.3.0/gems/activerecord-4.
ny_association.rb:171:in “each'
/usr/share/foreman/vendor/ruby/2.3.0/gems/activerecord-4.
ny_association.rb:171:in “delete_records'
/usr/share/foreman/vendor/ruby/2.3.0/gems/activerecord-4.
tion_association.rb:532:in "~ remove_records'
/usr/share/foreman/vendor/ruby/2.3.0/gems/activerecord-4.
tion_association.rb:525:in "block in delete_or_destroy'
/usr/share/foreman/vendor/ruby/2.3.0/gems/activerecord-4.
tion_association.rb:190:in “block in transaction'
/usr/share/foreman/vendor/ruby/2.3.0/gems/activerecord-4.
/abstract/database_statements.rb:211:in “transaction'
/usr/share/foreman/vendor/ruby/2.3.0/gems/activerecord-4.
:in “transaction'
/usr/share/foreman/vendor/ruby/2.3.0/gems/activerecord-4.
tion_association.rb:189:1in "transaction'
/usr/share/foreman/vendor/ruby/2.3.0/gems/activerecord-4.
tion_association.rb:525:in “delete_or_destroy'
/usr/share/foreman/vendor/ruby/2.3.0/gems/activerecord-4.
tion_association.rb:286:in “destroy'
/usr/share/foreman/vendor/ruby/2.3.0/gems/activerecord-4.
tion_association.rb:230:in “destroy_all'
/usr/share/foreman/vendor/ruby/2.3.0/gems/activerecord-4.
ny_association.rb:27:in “handle_dependency'
/usr/share/foreman/vendor/ruby/2.3.0/gems/activerecord-4.
r/association.rb:146:in “block in add_destroy_callbacks'

/usr/share/foreman/vendor/ruby/2.3.0/gems/activesupport-4.

in “instance_exec'

/usr/share/foreman/vendor/ruby/2.3.0/gems/activesupport—4.

in “block in make_lambda'

/usr/share/foreman/vendor/ruby/2.3.0/gems/activesupport—4.

in "block in halting'

/usr/share/foreman/vendor/ruby/2.3.0/gems/activesupport-4.

in "block in call'

/usr/share/foreman/vendor/ruby/2.3.0/gems/activesupport-4.

in “each'

/usr/share/foreman/vendor/ruby/2.3.0/gems/activesupport—4.

in “call'
.8/1lib/active_record/persistence.rb:185:

.8/1lib/active_record/associations/has_ma

.8/1lib/active_record/associations/has_ma

.8/1lib/active_record/associations/collec

.8/1lib/active_record/associations/collec

.8/1lib/active_record/associations/collec

.8/1lib/active_record/connection_adapters

.8/1lib/active_record/transactions.rb:220

.8/1lib/active_record/associations/collec

.8/1lib/active_record/associations/collec

.8/1lib/active_record/associations/collec

.8/1lib/active_record/associations/collec

.8/1lib/active_record/associations/has_ma

2

8/1lib/active_record/associations/builde
.8/1lib/active_support/callbacks.rb:448:
.8/1ib/active_support/callbacks.rb:448:
.8/1lib/active_support/callbacks.rb:164:
.8/1lib/active_support/callbacks.rb:504:
.8/1lib/active_support/callbacks.rb:504:

.8/1ib/active_support/callbacks.rb:504:
/usr/share/foreman/vendor/ruby/2.
n - __ _run_callbacks__ '
/usr/share/foreman/vendor/ruby/2.
in " _run_destroy_callbacks'
/usr/share/foreman/vendor/ruby/2.
“destroy'
/usr/share/foreman/vendor/ruby/2.
:in "block in destroy'
/usr/share/foreman/vendor/ruby/2.

3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:92:1
3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:778:
3.0/gems/activerecord-4.2.8/1lib/active_record/callbacks.rb:292:1in
3.0/gems/activerecord-4.2.8/1lib/active_record/transactions.rb:281

3.0/gems/activerecord-4.2.8/1lib/active_record/transactions.rb:351

:in "block in with_transaction_returning_status'

/usr/share/foreman/vendor/ruby/2.
/abstract/database_statements.rb:
/usr/share/foreman/vendor/ruby/2.

3.0/gems/activerecord-4.2.8/1lib/active_record/connection_adapters
213:in “block in transaction'
3.0/gems/activerecord-4.2.8/1lib/active_record/connection_adapters

/abstract/transaction.rb:184:in ‘within_new_transaction'

/usr/share/foreman/vendor/ruby/2.
/abstract/database_statements.rb:
/usr/share/foreman/vendor/ruby/2.
:in “transaction'

/usr/share/foreman/vendor/ruby/2.

3.0/gems/activerecord-4.2.8/1lib/active_record/connection_adapters
213:in “transaction'
3.0/gems/activerecord-4.2.8/1lib/active_record/transactions.rb:220

3.0/gems/activerecord-4.2.8/1lib/active_record/transactions.rb:348

:in ‘with_transaction_returning_status'

/usr/share/foreman/vendor/ruby/2.
:in “destroy'

3.0/gems/activerecord-4.2.8/1lib/active_record/transactions.rb:281

/usr/share/foreman/app/controllers/hosts_controller.rb:134:in “destroy'

/usr/share/foreman/vendor/ruby/2.
nder.rb:4:in "~ send_action'
/usr/share/foreman/vendor/ruby/2.
‘process_action’
/usr/share/foreman/vendor/ruby/2.
b:10:in ‘process_action’
/usr/share/foreman/vendor/ruby/2.
:in "block in process_action'
/usr/share/foreman/vendor/ruby/2.
in “call'
/usr/share/foreman/vendor/ruby/2.
in “block (2 levels) in compile'
/usr/share/foreman/vendor/ruby/2.
in “call'
/usr/share/foreman/vendor/ruby/2.
in “block (2 levels) in around'
/usr/share/foreman/vendor/ruby/2.
in "block (2 levels) in halting'

3.0/gems/actionpack-4.2.8/1lib/action_controller/metal/implicit_re
3.0/gems/actionpack-4.2.8/1ib/abstract_controller/base.rb:198:in

3.0/gems/actionpack-4.2.8/1lib/action_controller/metal/rendering.r
3.0/gems/actionpack-4.2.8/1lib/abstract_controller/callbacks.rb:20
3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:117:
3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:555:
3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:505:
3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:498:

3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:313:

/usr/share/foreman/app/controllers/concerns/application_shared.rb:15:in "set_timezone'

/usr/share/foreman/vendor/ruby/2.
in “block in make_lambda'
/usr/share/foreman/vendor/ruby/2.
in "block in halting'
/usr/share/foreman/vendor/ruby/2.
in "block in around'
/usr/share/foreman/vendor/ruby/2.
in “call'
/usr/share/foreman/vendor/ruby/2.
in “block (2 levels) in around'
/usr/share/foreman/vendor/ruby/2.
in “block (2 levels) in halting'

3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:432:
3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:312:
3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:497:
3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:505:
3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:498:

3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:313:

/usr/share/foreman/app/models/concerns/foreman/thread_session.rb:32:in “clear_thread'

/usr/share/foreman/vendor/ruby/2.
in “block in make_lambda'
/usr/share/foreman/vendor/ruby/2.
in “block in halting'
/usr/share/foreman/vendor/ruby/2.
in “block in around'
/usr/share/foreman/vendor/ruby/2.
in “call’
/usr/share/foreman/vendor/ruby/2.
in “block (2 levels) in around'
/usr/share/foreman/vendor/ruby/2.
in “block (2 levels) in halting'
3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:432:
3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:312:
3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:497:
3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:505:
3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:498:

3.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:313:
/usr/share/foreman/app/controllers/concerns/foreman/controller/topbar_sweeper.rb:12:in " set_topbar

_sweeper_controller'

/usr/share/foreman/vendor/ruby/2.3.0/gems/activesupport-4.2

in “block in make_lambda'

/usr/share/foreman/vendor/ruby/2.3.

in "block in halting'

/usr/share/foreman/vendor/ruby/2.3

in “block in around'

/usr/share/foreman/vendor/ruby/2.3.

in “call'

/usr/share/foreman/vendor/ruby/2.3.

in “block (2 levels) in around'

/usr/share/foreman/vendor/ruby/2.3.

in “block (2 levels) in halting'

/usr/share/foreman/vendor/ruby/2.3.
/usr/share/foreman/vendor/ruby/2.3.

in “public_send'

/usr/share/foreman/vendor/ruby/2.3.

in “block in make_lambda'

/usr/share/foreman/vendor/ruby/2.3.

in "block in halting'

/usr/share/foreman/vendor/ruby/2.3.

in “block in around'

/usr/share/foreman/vendor/ruby/2.3.

in “call'

/usr/share/foreman/vendor/ruby/2.3.

n ~__ _run_callbacks_ '

/usr/share/foreman/vendor/ruby/2.3.

in " _run_process_action_callbacks'

/usr/share/foreman/vendor/ruby/2.3.

n “run_callbacks'

/usr/share/foreman/vendor/ruby/2.3.

:in “process_action’

0/gems/activesupport—4.
.0/gems/activesupport-4.
0/gems/activesupport-4.

0/gems/activesupport-4.

0/gems/activesupport-4

ol

.8/1ib/active_support/callbacks.
.8/1lib/active_support/callbacks.
.8/1lib/active_support/callbacks.
.8/1lib/active_support/callbacks.
.8/1ib/active_support/callbacks.

.8/1lib/active_support/callbacks.

rb:

rb

rb:

rb:

rb:

rb:

0/gems/audited-4.4.1/1ib/audited/sweeper.rb:14:in "around'

0/gems/activesupport-4

0/gems/activesupport—-4.
0/gems/activesupport—4.
0/gems/activesupport—4.
0/gems/activesupport-4.
0/gems/activesupport—-4.

0/gems/activesupport—-4.

0/gems/activesupport—4

Y,

ol

.8/1lib/active_support/callbacks.
.8/1lib/active_support/callbacks.
.8/1lib/active_support/callbacks.
.8/1lib/active_support/callbacks.
.8/1lib/active_support/callbacks.
.8/1lib/active_support/callbacks.
.8/1lib/active_support/callbacks.

.8/1lib/active_support/callbacks.

rb:

rb:

rb:

rb:

rb:

rb:

rb:

rb:

432:

33123

497:

505:

498:

313:

455:

455:

312:

497:

5058

92:1

778:

81l:1

0/gems/actionpack-4.2.8/1lib/abstract_controller/callbacks.rb:19

/usr/share/foreman/vendor/ruby/2.3.0/gems/actionpack-4.2.8/1lib/action_controller/metal/rescue.rb:2

9:in “process_action'

/usr/share/foreman/vendor/ruby/2.3.0/gems/actionpack-4.2.8/1lib/action_controller/metal/instrumenta
tion.rb:32:in “block in process_action'

/usr/share/foreman/vendor/ruby/2.3.0/gems/activesupport-4.2.8/1lib/active_support/notifications.rb:

164:in
/usr/share/foreman/vendor/ruby/2

"block in instrument'

trumenter.rb:20:in "~ instrument'

/usr/share/foreman/vendor/ruby/2.3.

164:in "~ instrument'

/usr/share/foreman/vendor/ruby/2.3.

tion.rb:30:1in “process_action'

/usr/share/foreman/vendor/ruby/2.3.

per.rb:250:1in “process_action'

/usr/share/foreman/vendor/ruby/2.3.

_runtime.rb:18:in “process_action'

/usr/share/foreman/vendor/ruby/2.3.

"process'

/usr/share/foreman/vendor/ruby/2.3.

cess'

/usr/share/foreman/vendor/ruby/2.3.

dispatch'

/usr/share/foreman/vendor/ruby/2.3.

tion.rb:13:in “dispatch’

/usr/share/foreman/vendor/ruby/2.3.

block in action'

/usr/share/foreman/vendor/ruby/2.3.

b:74:in “dispatch'

/usr/share/foreman/vendor/ruby/2.3.

b:43:in "“serve'

/usr/share/foreman/vendor/ruby/2.3.

3:in "block in serve'

/usr/share/foreman/vendor/ruby/2.3.

0:in “each'’
.3.0/gems/activesupport-4.2.8/1lib/active_support/notifications/ins

0/gems/activesupport-4.2.8/1lib/active_support/notifications.rb:

0/gems/actionpack-4.2.8/1lib/action_controller/metal/instrumenta

0/gems/actionpack—-4.2.
0/gems/activerecord-4.
0/gems/actionpack-4.2.
0/gems/actionview—4.2.
0/gems/actionpack—-4.2.
0/gems/actionpack-4.2.
0/gems/actionpack-4.2.
0/gems/actionpack—-4.2.
0/gems/actionpack—-4.2.
0/gems/actionpack-4.2.

0/gems/actionpack-4.2.

8/lib/action_controller/metal/params_wrap

2.8/lib/active_record/railties/controller

8/1lib/abstract_controller/base.rb:137:1in

8/lib/action_view/rendering.rb:30:in “pro

8/1lib/action_controller/metal.rb:196:1in

8/lib/action_controller/metal/rack_delega

8/1lib/action_controller/metal.rb:237:1in

8/lib/action_dispatch/routing/route_set.r

8/lib/action_dispatch/routing/route_set.r

8/1lib/action_dispatch/journey/router.rb:4

8/1lib/action_dispatch/journey/router.rb:3
/usr/share/foreman/vendor/ruby/2.

0:in "serve'

/usr/share/foreman/vendor/ruby/2.

b:817:in “call’

/usr/share/foreman/vendor/ruby/2.

‘call'

/usr/share/foreman/vendor/ruby/2.

in “call"’

/usr/share/foreman/vendor/ruby/2.

ders.rb:27:in “call'

/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.

arser.rb:27:in “call'

w w w w

.0/gems/actionpack-4.2.8/1lib/action_dispatch/journey/router.rb:3
.0/gems/actionpack-4.2.8/1lib/action_dispatch/routing/route_set.r
.0/gems/apipie-rails-0.4.0/1lib/apipie/static_dispatcher.rb:65:1in
.0/gems/apipie-rails—-0.4.0/1lib/apipie/extractor/recorder.rb:132:
.0/gems/apipie-rails-0.4.0/1lib/apipie/middleware/checksum_in_hea
.0/gems/rack-1.6.5/1ib/rack/etag.rb:24:in “call’
.0/gems/rack-1.6.5/1ib/rack/conditionalget.rb:38:in “call’

.0/gems/rack-1.6.5/1ib/rack/head.rb:13:in “call’
.0/gems/actionpack-4.2.8/1lib/action_dispatch/middleware/params_p

/usr/share/foreman/lib/middleware/catch_json_parse_errors.rb:8:in “call'

/usr/share/foreman/vendor/ruby/2.3.0/gems/actionpack-4.2.8/1lib/action_dispatch/middleware/flash.rb

:260:1in “call’

/usr/share/foreman/vendor/ruby/2.

xt'

/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.

rb:560:in “call'

/usr/share/foreman/vendor/ruby/2.

n “call'

/usr/share/foreman/vendor/ruby/2.
/abstract/connection_pool.rb:653:
/usr/share/foreman/vendor/ruby/2.

S.rb:29:in “block in call'

/usr/share/foreman/vendor/ruby/2.

n “_ run_callbacks_ '

/usr/share/foreman/vendor/ruby/2.

in " _run_call_callbacks'

/usr/share/foreman/vendor/ruby/2.

n “run_callbacks'

/usr/share/foreman/vendor/ruby/2.

s.rb:27:in “call'

/usr/share/foreman/vendor/ruby/2.

p.rb:78:in “call'

/usr/share/foreman/vendor/ruby/2.

ceptions.rb:17:in “call'

/usr/share/foreman/vendor/ruby/2.

eptions.rb:30:in “call'

/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.

3

in

3

3

3

3o

.0/gems/rack-1.6.5/1ib/rack/session/abstract/id.rb:225:in " conte

.0/gems/rack-1.6.5/1ib/rack/session/abstract/id.rb:220:in “call'
.0/gems/actionpack-4.2.8/1lib/action_dispatch/middleware/cookies.

.0/gems/activerecord-4.2.8/1lib/active_record/query_cache.rb:36:1
.0/gems/activerecord-4.2.8/1lib/active_record/connection_adapters
‘call!

.0/gems/actionpack-4.2.8/1lib/action_dispatch/middleware/callback
.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:88:1i
.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:778:
.0/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:81:1
.0/gems/actionpack-4.2.8/1lib/action_dispatch/middleware/callback
.0/gems/actionpack-4.2.8/1lib/action_dispatch/middleware/remote_i
.0/gems/actionpack-4.2.8/1lib/action_dispatch/middleware/debug_ex
.0/gems/actionpack-4.2.

8/1lib/action_dispatch/middleware/show_exc

.0/gems/railties—-4.2.8/1lib/rails/rack/logger.rb:38:in “call_app'
0/gems/railties-4.2.8/1lib/rails/rack/logger.rb:22:in “call'

/usr/share/foreman/lib/middleware/tagged_logging.rb:18:in “call'

/usr/share/foreman/vendor/ruby/2.

id.rb:21:in “call’

/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
‘call'

cal_cache_middleware.rb:28:1in

3

3
3
3

.0/gems/actionpack-4.2.8/1lib/action_dispatch/middleware/request_
.0/gems/rack-1.6.5/1ib/rack/methodoverride.rb:22:in “call'
.0/gems/rack-1.6.5/1ib/rack/runtime.rb:18:in ‘call'
.0/gems/activesupport-4.2.8/1lib/active_support/cache/strategy/lo

/usr/share/foreman/vendor/ruby/2.3.0/gems/actionpack-4.2.8/1lib/action_dispatch/middleware/static.r

b:120:in “call'

/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.

:in “call’

/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.

ng'

/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.

w w

w w w w

w

3
3

.0/gems/rack-1.6.5/1lib/rack/sendfile.rb:113:in "call’
.0/gems/secure_headers-3.6.2/1ib/secure_headers/middleware.rb:12

.0/gems/railties-4.

2.8/1lib/rails/engine.rb:518:in “call’
.0/gems/railties-4.2
2
2

.8/lib/rails/application.rb:165:in ‘call'
.8/1ib/rails/railtie.rb:194:in “public_send'
.8/1lib/rails/railtie.rb:194:in "method_missi

.0/gems/railties-4.
.0/gems/railties—4.

.0/gems/rack-1.6.5/1lib/rack/urlmap.rb:66:in ‘block in call'
.0/gems/rack-1.6.5/1lib/rack/urlmap.rb:50:in “each'
.0/gems/rack-1.6.5/1ib/rack/urlmap.rb:50:in “call’

/usr/lib/ruby/vendor_ruby/phusion_passenger/rack/thread_handler_extension.rb:97:in "process_reques

t!
/usr/lib/ruby/vendor_ruby/phusion_passenger/request_handler/thread_handler.rb:160:in "accept_and_p
rocess_next_request'
/usr/lib/ruby/vendor_ruby/phusion_passenger/request_handler/thread_handler.rb:113:in "main_loop'
/usr/lib/ruby/vendor_ruby/phusion_passenger/request_handler.rb:416:in ‘block (3 levels) in start_t
hreads'

/usr/lib/ruby/vendor_ruby/phusion_passenger/utils.rb:113:in “block in create_thread_and_abort_on_e
xception'
/usr/share/foreman/vendor/ruby/2.3.0/gems/logging-2.2.0/1ib/logging/diagnostic_context.rb:474:in °
block in create_with_logging_context'

Related issues:
Related to Foreman - Bug #14702: Improve error messages when deleting multipl... Closed

History

#1 - 04/17/2017 04:18 AM - Daniel Lobato Garcia

- translation missing: en.field_release set to 209

Setting to 1.15 as we should fix this for the next RC

#2 - 04/17/2017 04:56 AM - Daniel Lobato Garcia

Have you tried with multiple hosts? Does this happen with every host? Have you tried with managed vs unmanaged hosts?
I'm trying to reproduce this on 1.15 but to no avail yet

#3 - 04/17/2017 12:14 PM - Josh Benner
It happens reproducibly for me on managed hosts, deleting using the "delete" button on the single-host detail page. Process:
1. Create host (only minimum required fields, single interface)
2. Click "delete" at /hosts/<hostname>
3. Observe error
4. Click "back" on error page
5. Navigate to host page again

6. Click "delete" button
7. Successful delete

If | follow the same process, but first flag it as unmanaged, the delete is successful.

#4 - 04/18/2017 03:37 AM - Daniel Lobato Garcia

Thanks that's helpful. | will report back the results after trying to do exactly that.

#5 - 05/12/2017 05:53 AM - Dominic Cleal

- Related to Bug #14702: Improve error messages when deleting multiple host fails because of proxy errors added

#6 - 05/12/2017 05:54 AM - Dominic Cleal
- Category set to Host creation

- translation missing: en.field_release deleted (209)

Unset the release as it's passed.

This could also be caused by a smart proxy error or a plugin, do check the smart proxy log at the time of the deletion for errors and ensure you can
reproduce this using Foreman without any plugins.

#7 - 05/20/2017 11:55 AM - Anonymous

Josh, what's the status here?

#8 - 05/22/2017 06:18 AM - Dominic Cleal

The description in comment 3 sounds similar to #19599, but I'd need to confirm that DHCP is in use (possibly with the ISC DHCP provider), see the
corresponding smart proxy logs, and more of production.log before suggesting it's a duplicate.

#9 - 07/31/2017 06:45 PM - Anonymous

- Status changed from New to Feedback
